<?php

namespace Modules\Banner\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Product\Services\ProductService;
use Modules\Banner\Requests\Admin\BannerRequest;
use Modules\Banner\Services\BannerService;

class BannerController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/banners';
    /** View folder */
    private $viewDirectory= 'admin.banners.';
    //

    public function __construct(
        private BannerService $bannerService,
        private ProductService $productService,
    )
    {}

    /**
     * Display a listing of the banners.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('banners.head');
        $products = $this->productService->get([]);
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the banners.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $banners= $this->bannerService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Banner.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('banners.store');
        $head= __('banners.new');
        $products = $this->productService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Banner in storage.
     * @param BannerRequest $request
     * @return JsonResponse
     */
    public function store(BannerRequest $request) :JsonResponse
    {
        $this->bannerService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Banner.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $banner = $this->bannerService->getItem($id);
        if (!$banner)
        {
            abort(404);
        }
        $action= route('banners.update', $banner->id);
        $head= __('banners.edit');
        $products = $this->productService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Banner in storage.
     * @param BannerRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(BannerRequest $request, int $id) :JsonResponse
    {
        $banner = $this->bannerService->checkItem($id);
        if (!$banner)
        {
            abort(404);
        }
        $this->bannerService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Banner from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->bannerService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several banners by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->bannerService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Banner from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->bannerService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several banners by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->bannerService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('banners.index'),
        ];
        return ResponseService::response($response);
    }
}
